/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/accessories/StringDateFormatter.as
 * org.apache.royale.html.accessories.StringDateFormatter
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.accessories.StringDateFormatter');

goog.require('org.apache.royale.html.accessories.SimpleDateFormatter');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.html.accessories.SimpleDateFormatter}
 */
org.apache.royale.html.accessories.StringDateFormatter = function() {
  org.apache.royale.html.accessories.StringDateFormatter.base(this, 'constructor');
};
goog.inherits(org.apache.royale.html.accessories.StringDateFormatter, org.apache.royale.html.accessories.SimpleDateFormatter);


/**
 * Formats the date.
 * If a String is passed in, the date string is formatted using the dateFormat.
 * If a Date is passed in, it formats the same as other Date formatters.
 * @override
 */
org.apache.royale.html.accessories.StringDateFormatter.prototype.format = function(value) {
  if (org.apache.royale.utils.Language.is(value, Date)) {
    return org.apache.royale.html.accessories.StringDateFormatter.superClass_.format.apply(this, [ value] );
  }
  var /** @type {string} */ str = org.apache.royale.utils.Language.as(value, String);
  var /** @type {string} */ lastChar = org.apache.royale.utils.Language.string(str ? str[str.length - 1] : "");
  str = str.replace(/[^0-9]/g, "");
  var /** @type {string} */ result = "";
  var /** @type {Array} */ tokens = this.dateFormat.split(this._separator);
  var /** @type {number} */ length = (tokens.length) >> 0;
  var /** @type {string} */ part;
  var /** @type {number} */ val;
  for (var /** @type {number} */ i = 0; i < length; i++) {
    if (!str)
      break;
    var /** @type {string} */ token = org.apache.royale.utils.Language.string(tokens[i]);
    switch (token) {
      case "YYYY":
        part = str.substr(0, 4);
        str = str.substr(4);
        result += part;
        break;
      case "YY":
        part = str.substr(0, 2);
        str = str.substr(2);
        result += part;
        break;
      case "M":
      
      case "MM":
        part = str.substr(0, 2);
        val = Number(part);
        if (val > 12) {
          part = "0" + str.substr(0, 1);
          str = str.substr(1);
        } else {
          str = str.substr(2);
          if (part.length == 1 && lastChar == this._separator)
            part = "0" + part;
        }
        result += part;
        break;
      case "DD":
      
      case "D":
        part = str.substr(0, 2);
        val = Number(part);
        if (val > 31) {
          part = "0" + str.substr(0, 1);
          str = str.substr(1);
        } else {
          str = str.substr(2);
          if (part.length == 1 && lastChar == this._separator)
            part = "0" + part;
        }
        result += part;
        break;
    }
    if ((str || lastChar == this._separator) && i <= length - 2) {
      result += this._separator;
    }
  }
  return result;
};


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.accessories.StringDateFormatter.prototype.org_apache_royale_html_accessories_StringDateFormatter__maxMonths = 12;


/**
 * @private
 * @param {number} value
 * @return {boolean}
 */
org.apache.royale.html.accessories.StringDateFormatter.prototype.org_apache_royale_html_accessories_StringDateFormatter_isValidMonth = function(value) {
  if (isNaN(value))
    return false;
  if (Math.round(value) != value)
    return false;
  if (value > this.org_apache_royale_html_accessories_StringDateFormatter__maxMonths)
    return false;
  return true;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.accessories.StringDateFormatter.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'StringDateFormatter', qName: 'org.apache.royale.html.accessories.StringDateFormatter', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.accessories.StringDateFormatter.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'StringDateFormatter': { type: '', declaredBy: 'org.apache.royale.html.accessories.StringDateFormatter'},
        'format': { type: 'String', declaredBy: 'org.apache.royale.html.accessories.StringDateFormatter', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.html.accessories.StringDateFormatter.prototype.ROYALE_COMPILE_FLAGS = 10;